"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var curry2_1 = require("./curry2");
var curry3_1 = require("./curry3");
var curry4_1 = require("./curry4");
var curry5_1 = require("./curry5");
var curryN_1 = require("../curryN");
/**
 * Given a function it returns a curried version of that function.
 * @name curry(fn: Fuction): CurriedFunction
 */
exports.curry = function curry(fn) {
    switch (fn.length) {
        case 0:
            return fn;
        case 1:
            return fn;
        case 2:
            return curry2_1.curry2(fn);
        case 3:
            return curry3_1.curry3(fn);
        case 4:
            return curry4_1.curry4(fn);
        case 5:
            return curry5_1.curry5(fn);
        default:
            return curryN_1.curryN(fn.length, fn);
    }
};
//# sourceMappingURL=curry.js.map