"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Left-to-right function composition.
 * @name pipe<A, B>(...fns: Array<Function>): (value: A) => B
 */
exports.pipe = function pipe() {
    var fns = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        fns[_i] = arguments[_i];
    }
    return function (a) {
        switch (fns.length) {
            case 1:
                return fns[0](a);
            case 2:
                return fns[1](fns[0](a));
            case 3:
                return fns[2](fns[1](fns[0](a)));
            case 4:
                return fns[3](fns[2](fns[1](fns[0](a))));
            case 5:
                return fns[4](fns[3](fns[2](fns[1](fns[0](a)))));
            default:
                return fns.reduce(function (accumulator, value) { return value(accumulator); }, a);
        }
    };
};
//# sourceMappingURL=pipe.js.map